//C++ Abstract Syntax Implementation generated by the BNF Converter.
#include <algorithm>
#include <string>
#include <vector>
#include <latte/latte/Absyn.h>
namespace Latte
{
/********************   IdentPos    ********************/
IdentPos::IdentPos(Ident p1)
{
  ident_ = p1;

}

IdentPos::IdentPos(const IdentPos & other)
{
  ident_ = other.ident_;

}

IdentPos &IdentPos::operator=(const IdentPos & other)
{
  IdentPos tmp(other);
  swap(tmp);
  return *this;
}

void IdentPos::swap(IdentPos & other)
{
  std::swap(ident_, other.ident_);

}

IdentPos::~IdentPos()
{

}

void IdentPos::accept(Visitor *v)
{
  v->visitIdentPos(this);
}

IdentPos *IdentPos::clone() const
{
  return new IdentPos(*this);
}



/********************   Prog    ********************/
Prog::Prog(ListTopDef *p1)
{
  listtopdef_ = p1;

}

Prog::Prog(const Prog & other)
{
  listtopdef_ = other.listtopdef_->clone();

}

Prog &Prog::operator=(const Prog & other)
{
  Prog tmp(other);
  swap(tmp);
  return *this;
}

void Prog::swap(Prog & other)
{
  std::swap(listtopdef_, other.listtopdef_);

}

Prog::~Prog()
{
  delete(listtopdef_);

}

void Prog::accept(Visitor *v)
{
  v->visitProg(this);
}

Prog *Prog::clone() const
{
  return new Prog(*this);
}



/********************   ClsDefTop    ********************/
ClsDefTop::ClsDefTop(ClassDef *p1)
{
  classdef_ = p1;

}

ClsDefTop::ClsDefTop(const ClsDefTop & other)
{
  classdef_ = other.classdef_->clone();

}

ClsDefTop &ClsDefTop::operator=(const ClsDefTop & other)
{
  ClsDefTop tmp(other);
  swap(tmp);
  return *this;
}

void ClsDefTop::swap(ClsDefTop & other)
{
  std::swap(classdef_, other.classdef_);

}

ClsDefTop::~ClsDefTop()
{
  delete(classdef_);

}

void ClsDefTop::accept(Visitor *v)
{
  v->visitClsDefTop(this);
}

ClsDefTop *ClsDefTop::clone() const
{
  return new ClsDefTop(*this);
}



/********************   FnDefTop    ********************/
FnDefTop::FnDefTop(FunDef *p1)
{
  fundef_ = p1;

}

FnDefTop::FnDefTop(const FnDefTop & other)
{
  fundef_ = other.fundef_->clone();

}

FnDefTop &FnDefTop::operator=(const FnDefTop & other)
{
  FnDefTop tmp(other);
  swap(tmp);
  return *this;
}

void FnDefTop::swap(FnDefTop & other)
{
  std::swap(fundef_, other.fundef_);

}

FnDefTop::~FnDefTop()
{
  delete(fundef_);

}

void FnDefTop::accept(Visitor *v)
{
  v->visitFnDefTop(this);
}

FnDefTop *FnDefTop::clone() const
{
  return new FnDefTop(*this);
}



/********************   FnDef    ********************/
FnDef::FnDef(Type *p1, IdentP *p2, ListArg *p3, Block *p4)
{
  type_ = p1;
  identp_ = p2;
  listarg_ = p3;
  block_ = p4;

}

FnDef::FnDef(const FnDef & other)
{
  type_ = other.type_->clone();
  identp_ = other.identp_->clone();
  listarg_ = other.listarg_->clone();
  block_ = other.block_->clone();

}

FnDef &FnDef::operator=(const FnDef & other)
{
  FnDef tmp(other);
  swap(tmp);
  return *this;
}

void FnDef::swap(FnDef & other)
{
  std::swap(type_, other.type_);
  std::swap(identp_, other.identp_);
  std::swap(listarg_, other.listarg_);
  std::swap(block_, other.block_);

}

FnDef::~FnDef()
{
  delete(type_);
  delete(identp_);
  delete(listarg_);
  delete(block_);

}

void FnDef::accept(Visitor *v)
{
  v->visitFnDef(this);
}

FnDef *FnDef::clone() const
{
  return new FnDef(*this);
}



/********************   Ar    ********************/
Ar::Ar(Type *p1, IdentP *p2)
{
  type_ = p1;
  identp_ = p2;

}

Ar::Ar(const Ar & other)
{
  type_ = other.type_->clone();
  identp_ = other.identp_->clone();

}

Ar &Ar::operator=(const Ar & other)
{
  Ar tmp(other);
  swap(tmp);
  return *this;
}

void Ar::swap(Ar & other)
{
  std::swap(type_, other.type_);
  std::swap(identp_, other.identp_);

}

Ar::~Ar()
{
  delete(type_);
  delete(identp_);

}

void Ar::accept(Visitor *v)
{
  v->visitAr(this);
}

Ar *Ar::clone() const
{
  return new Ar(*this);
}



/********************   ClsDef    ********************/
ClsDef::ClsDef(IdentP *p1, ClassBlock *p2)
{
  identp_ = p1;
  classblock_ = p2;

}

ClsDef::ClsDef(const ClsDef & other)
{
  identp_ = other.identp_->clone();
  classblock_ = other.classblock_->clone();

}

ClsDef &ClsDef::operator=(const ClsDef & other)
{
  ClsDef tmp(other);
  swap(tmp);
  return *this;
}

void ClsDef::swap(ClsDef & other)
{
  std::swap(identp_, other.identp_);
  std::swap(classblock_, other.classblock_);

}

ClsDef::~ClsDef()
{
  delete(identp_);
  delete(classblock_);

}

void ClsDef::accept(Visitor *v)
{
  v->visitClsDef(this);
}

ClsDef *ClsDef::clone() const
{
  return new ClsDef(*this);
}



/********************   ClsExtDef    ********************/
ClsExtDef::ClsExtDef(IdentP *p1, Ident p2, ClassBlock *p3)
{
  identp_ = p1;
  ident_ = p2;
  classblock_ = p3;

}

ClsExtDef::ClsExtDef(const ClsExtDef & other)
{
  identp_ = other.identp_->clone();
  ident_ = other.ident_;
  classblock_ = other.classblock_->clone();

}

ClsExtDef &ClsExtDef::operator=(const ClsExtDef & other)
{
  ClsExtDef tmp(other);
  swap(tmp);
  return *this;
}

void ClsExtDef::swap(ClsExtDef & other)
{
  std::swap(identp_, other.identp_);
  std::swap(ident_, other.ident_);
  std::swap(classblock_, other.classblock_);

}

ClsExtDef::~ClsExtDef()
{
  delete(identp_);
  delete(classblock_);

}

void ClsExtDef::accept(Visitor *v)
{
  v->visitClsExtDef(this);
}

ClsExtDef *ClsExtDef::clone() const
{
  return new ClsExtDef(*this);
}



/********************   ClsBlk    ********************/
ClsBlk::ClsBlk(ListClassBlockDef *p1)
{
  listclassblockdef_ = p1;

}

ClsBlk::ClsBlk(const ClsBlk & other)
{
  listclassblockdef_ = other.listclassblockdef_->clone();

}

ClsBlk &ClsBlk::operator=(const ClsBlk & other)
{
  ClsBlk tmp(other);
  swap(tmp);
  return *this;
}

void ClsBlk::swap(ClsBlk & other)
{
  std::swap(listclassblockdef_, other.listclassblockdef_);

}

ClsBlk::~ClsBlk()
{
  delete(listclassblockdef_);

}

void ClsBlk::accept(Visitor *v)
{
  v->visitClsBlk(this);
}

ClsBlk *ClsBlk::clone() const
{
  return new ClsBlk(*this);
}



/********************   ClsMthDef    ********************/
ClsMthDef::ClsMthDef(FunDef *p1)
{
  fundef_ = p1;

}

ClsMthDef::ClsMthDef(const ClsMthDef & other)
{
  fundef_ = other.fundef_->clone();

}

ClsMthDef &ClsMthDef::operator=(const ClsMthDef & other)
{
  ClsMthDef tmp(other);
  swap(tmp);
  return *this;
}

void ClsMthDef::swap(ClsMthDef & other)
{
  std::swap(fundef_, other.fundef_);

}

ClsMthDef::~ClsMthDef()
{
  delete(fundef_);

}

void ClsMthDef::accept(Visitor *v)
{
  v->visitClsMthDef(this);
}

ClsMthDef *ClsMthDef::clone() const
{
  return new ClsMthDef(*this);
}



/********************   ClsFldDef    ********************/
ClsFldDef::ClsFldDef(Type *p1, ListClsFldDefItem *p2)
{
  type_ = p1;
  listclsflddefitem_ = p2;

}

ClsFldDef::ClsFldDef(const ClsFldDef & other)
{
  type_ = other.type_->clone();
  listclsflddefitem_ = other.listclsflddefitem_->clone();

}

ClsFldDef &ClsFldDef::operator=(const ClsFldDef & other)
{
  ClsFldDef tmp(other);
  swap(tmp);
  return *this;
}

void ClsFldDef::swap(ClsFldDef & other)
{
  std::swap(type_, other.type_);
  std::swap(listclsflddefitem_, other.listclsflddefitem_);

}

ClsFldDef::~ClsFldDef()
{
  delete(type_);
  delete(listclsflddefitem_);

}

void ClsFldDef::accept(Visitor *v)
{
  v->visitClsFldDef(this);
}

ClsFldDef *ClsFldDef::clone() const
{
  return new ClsFldDef(*this);
}



/********************   ClsFldDefIt    ********************/
ClsFldDefIt::ClsFldDefIt(IdentP *p1)
{
  identp_ = p1;

}

ClsFldDefIt::ClsFldDefIt(const ClsFldDefIt & other)
{
  identp_ = other.identp_->clone();

}

ClsFldDefIt &ClsFldDefIt::operator=(const ClsFldDefIt & other)
{
  ClsFldDefIt tmp(other);
  swap(tmp);
  return *this;
}

void ClsFldDefIt::swap(ClsFldDefIt & other)
{
  std::swap(identp_, other.identp_);

}

ClsFldDefIt::~ClsFldDefIt()
{
  delete(identp_);

}

void ClsFldDefIt::accept(Visitor *v)
{
  v->visitClsFldDefIt(this);
}

ClsFldDefIt *ClsFldDefIt::clone() const
{
  return new ClsFldDefIt(*this);
}



/********************   Blk    ********************/
Blk::Blk(ListStmt *p1)
{
  liststmt_ = p1;

}

Blk::Blk(const Blk & other)
{
  liststmt_ = other.liststmt_->clone();

}

Blk &Blk::operator=(const Blk & other)
{
  Blk tmp(other);
  swap(tmp);
  return *this;
}

void Blk::swap(Blk & other)
{
  std::swap(liststmt_, other.liststmt_);

}

Blk::~Blk()
{
  delete(liststmt_);

}

void Blk::accept(Visitor *v)
{
  v->visitBlk(this);
}

Blk *Blk::clone() const
{
  return new Blk(*this);
}



/********************   Decl    ********************/
Decl::Decl(Type *p1, ListDeclItem *p2)
{
  type_ = p1;
  listdeclitem_ = p2;

}

Decl::Decl(const Decl & other)
{
  type_ = other.type_->clone();
  listdeclitem_ = other.listdeclitem_->clone();

}

Decl &Decl::operator=(const Decl & other)
{
  Decl tmp(other);
  swap(tmp);
  return *this;
}

void Decl::swap(Decl & other)
{
  std::swap(type_, other.type_);
  std::swap(listdeclitem_, other.listdeclitem_);

}

Decl::~Decl()
{
  delete(type_);
  delete(listdeclitem_);

}

void Decl::accept(Visitor *v)
{
  v->visitDecl(this);
}

Decl *Decl::clone() const
{
  return new Decl(*this);
}



/********************   Assign    ********************/
Assign::Assign(Expr *p1, Expr *p2)
{
  expr_1 = p1;
  expr_2 = p2;

}

Assign::Assign(const Assign & other)
{
  expr_1 = other.expr_1->clone();
  expr_2 = other.expr_2->clone();

}

Assign &Assign::operator=(const Assign & other)
{
  Assign tmp(other);
  swap(tmp);
  return *this;
}

void Assign::swap(Assign & other)
{
  std::swap(expr_1, other.expr_1);
  std::swap(expr_2, other.expr_2);

}

Assign::~Assign()
{
  delete(expr_1);
  delete(expr_2);

}

void Assign::accept(Visitor *v)
{
  v->visitAssign(this);
}

Assign *Assign::clone() const
{
  return new Assign(*this);
}



/********************   Incr    ********************/
Incr::Incr(Expr *p1)
{
  expr_ = p1;

}

Incr::Incr(const Incr & other)
{
  expr_ = other.expr_->clone();

}

Incr &Incr::operator=(const Incr & other)
{
  Incr tmp(other);
  swap(tmp);
  return *this;
}

void Incr::swap(Incr & other)
{
  std::swap(expr_, other.expr_);

}

Incr::~Incr()
{
  delete(expr_);

}

void Incr::accept(Visitor *v)
{
  v->visitIncr(this);
}

Incr *Incr::clone() const
{
  return new Incr(*this);
}



/********************   Decr    ********************/
Decr::Decr(Expr *p1)
{
  expr_ = p1;

}

Decr::Decr(const Decr & other)
{
  expr_ = other.expr_->clone();

}

Decr &Decr::operator=(const Decr & other)
{
  Decr tmp(other);
  swap(tmp);
  return *this;
}

void Decr::swap(Decr & other)
{
  std::swap(expr_, other.expr_);

}

Decr::~Decr()
{
  delete(expr_);

}

void Decr::accept(Visitor *v)
{
  v->visitDecr(this);
}

Decr *Decr::clone() const
{
  return new Decr(*this);
}



/********************   Ret    ********************/
Ret::Ret(Expr *p1)
{
  expr_ = p1;

}

Ret::Ret(const Ret & other)
{
  expr_ = other.expr_->clone();

}

Ret &Ret::operator=(const Ret & other)
{
  Ret tmp(other);
  swap(tmp);
  return *this;
}

void Ret::swap(Ret & other)
{
  std::swap(expr_, other.expr_);

}

Ret::~Ret()
{
  delete(expr_);

}

void Ret::accept(Visitor *v)
{
  v->visitRet(this);
}

Ret *Ret::clone() const
{
  return new Ret(*this);
}



/********************   VRet    ********************/
VRet::VRet()
{

}

VRet::VRet(const VRet & other)
{

}

VRet &VRet::operator=(const VRet & other)
{
  VRet tmp(other);
  swap(tmp);
  return *this;
}

void VRet::swap(VRet & other)
{

}

VRet::~VRet()
{

}

void VRet::accept(Visitor *v)
{
  v->visitVRet(this);
}

VRet *VRet::clone() const
{
  return new VRet(*this);
}



/********************   While    ********************/
While::While(Expr *p1, Stmt *p2)
{
  expr_ = p1;
  stmt_ = p2;

}

While::While(const While & other)
{
  expr_ = other.expr_->clone();
  stmt_ = other.stmt_->clone();

}

While &While::operator=(const While & other)
{
  While tmp(other);
  swap(tmp);
  return *this;
}

void While::swap(While & other)
{
  std::swap(expr_, other.expr_);
  std::swap(stmt_, other.stmt_);

}

While::~While()
{
  delete(expr_);
  delete(stmt_);

}

void While::accept(Visitor *v)
{
  v->visitWhile(this);
}

While *While::clone() const
{
  return new While(*this);
}



/********************   For    ********************/
For::For(Type *p1, Ident p2, Expr *p3, Stmt *p4)
{
  type_ = p1;
  ident_ = p2;
  expr_ = p3;
  stmt_ = p4;

}

For::For(const For & other)
{
  type_ = other.type_->clone();
  ident_ = other.ident_;
  expr_ = other.expr_->clone();
  stmt_ = other.stmt_->clone();

}

For &For::operator=(const For & other)
{
  For tmp(other);
  swap(tmp);
  return *this;
}

void For::swap(For & other)
{
  std::swap(type_, other.type_);
  std::swap(ident_, other.ident_);
  std::swap(expr_, other.expr_);
  std::swap(stmt_, other.stmt_);

}

For::~For()
{
  delete(type_);
  delete(expr_);
  delete(stmt_);

}

void For::accept(Visitor *v)
{
  v->visitFor(this);
}

For *For::clone() const
{
  return new For(*this);
}



/********************   If    ********************/
If::If(Expr *p1, Stmt *p2)
{
  expr_ = p1;
  stmt_ = p2;

}

If::If(const If & other)
{
  expr_ = other.expr_->clone();
  stmt_ = other.stmt_->clone();

}

If &If::operator=(const If & other)
{
  If tmp(other);
  swap(tmp);
  return *this;
}

void If::swap(If & other)
{
  std::swap(expr_, other.expr_);
  std::swap(stmt_, other.stmt_);

}

If::~If()
{
  delete(expr_);
  delete(stmt_);

}

void If::accept(Visitor *v)
{
  v->visitIf(this);
}

If *If::clone() const
{
  return new If(*this);
}



/********************   IfElse    ********************/
IfElse::IfElse(Expr *p1, Stmt *p2, Stmt *p3)
{
  expr_ = p1;
  stmt_1 = p2;
  stmt_2 = p3;

}

IfElse::IfElse(const IfElse & other)
{
  expr_ = other.expr_->clone();
  stmt_1 = other.stmt_1->clone();
  stmt_2 = other.stmt_2->clone();

}

IfElse &IfElse::operator=(const IfElse & other)
{
  IfElse tmp(other);
  swap(tmp);
  return *this;
}

void IfElse::swap(IfElse & other)
{
  std::swap(expr_, other.expr_);
  std::swap(stmt_1, other.stmt_1);
  std::swap(stmt_2, other.stmt_2);

}

IfElse::~IfElse()
{
  delete(expr_);
  delete(stmt_1);
  delete(stmt_2);

}

void IfElse::accept(Visitor *v)
{
  v->visitIfElse(this);
}

IfElse *IfElse::clone() const
{
  return new IfElse(*this);
}



/********************   BStmt    ********************/
BStmt::BStmt(Block *p1)
{
  block_ = p1;

}

BStmt::BStmt(const BStmt & other)
{
  block_ = other.block_->clone();

}

BStmt &BStmt::operator=(const BStmt & other)
{
  BStmt tmp(other);
  swap(tmp);
  return *this;
}

void BStmt::swap(BStmt & other)
{
  std::swap(block_, other.block_);

}

BStmt::~BStmt()
{
  delete(block_);

}

void BStmt::accept(Visitor *v)
{
  v->visitBStmt(this);
}

BStmt *BStmt::clone() const
{
  return new BStmt(*this);
}



/********************   Empty    ********************/
Empty::Empty()
{

}

Empty::Empty(const Empty & other)
{

}

Empty &Empty::operator=(const Empty & other)
{
  Empty tmp(other);
  swap(tmp);
  return *this;
}

void Empty::swap(Empty & other)
{

}

Empty::~Empty()
{

}

void Empty::accept(Visitor *v)
{
  v->visitEmpty(this);
}

Empty *Empty::clone() const
{
  return new Empty(*this);
}



/********************   Exp    ********************/
Exp::Exp(Expr *p1)
{
  expr_ = p1;

}

Exp::Exp(const Exp & other)
{
  expr_ = other.expr_->clone();

}

Exp &Exp::operator=(const Exp & other)
{
  Exp tmp(other);
  swap(tmp);
  return *this;
}

void Exp::swap(Exp & other)
{
  std::swap(expr_, other.expr_);

}

Exp::~Exp()
{
  delete(expr_);

}

void Exp::accept(Visitor *v)
{
  v->visitExp(this);
}

Exp *Exp::clone() const
{
  return new Exp(*this);
}



/********************   NoInit    ********************/
NoInit::NoInit(Ident p1)
{
  ident_ = p1;

}

NoInit::NoInit(const NoInit & other)
{
  ident_ = other.ident_;

}

NoInit &NoInit::operator=(const NoInit & other)
{
  NoInit tmp(other);
  swap(tmp);
  return *this;
}

void NoInit::swap(NoInit & other)
{
  std::swap(ident_, other.ident_);

}

NoInit::~NoInit()
{

}

void NoInit::accept(Visitor *v)
{
  v->visitNoInit(this);
}

NoInit *NoInit::clone() const
{
  return new NoInit(*this);
}



/********************   Init    ********************/
Init::Init(Ident p1, Expr *p2)
{
  ident_ = p1;
  expr_ = p2;

}

Init::Init(const Init & other)
{
  ident_ = other.ident_;
  expr_ = other.expr_->clone();

}

Init &Init::operator=(const Init & other)
{
  Init tmp(other);
  swap(tmp);
  return *this;
}

void Init::swap(Init & other)
{
  std::swap(ident_, other.ident_);
  std::swap(expr_, other.expr_);

}

Init::~Init()
{
  delete(expr_);

}

void Init::accept(Visitor *v)
{
  v->visitInit(this);
}

Init *Init::clone() const
{
  return new Init(*this);
}



/********************   TClass    ********************/
TClass::TClass(Ident p1)
{
  ident_ = p1;

}

TClass::TClass(const TClass & other)
{
  ident_ = other.ident_;

}

TClass &TClass::operator=(const TClass & other)
{
  TClass tmp(other);
  swap(tmp);
  return *this;
}

void TClass::swap(TClass & other)
{
  std::swap(ident_, other.ident_);

}

TClass::~TClass()
{

}

void TClass::accept(Visitor *v)
{
  v->visitTClass(this);
}

TClass *TClass::clone() const
{
  return new TClass(*this);
}



/********************   TInt    ********************/
TInt::TInt()
{

}

TInt::TInt(const TInt & other)
{

}

TInt &TInt::operator=(const TInt & other)
{
  TInt tmp(other);
  swap(tmp);
  return *this;
}

void TInt::swap(TInt & other)
{

}

TInt::~TInt()
{

}

void TInt::accept(Visitor *v)
{
  v->visitTInt(this);
}

TInt *TInt::clone() const
{
  return new TInt(*this);
}



/********************   TStr    ********************/
TStr::TStr()
{

}

TStr::TStr(const TStr & other)
{

}

TStr &TStr::operator=(const TStr & other)
{
  TStr tmp(other);
  swap(tmp);
  return *this;
}

void TStr::swap(TStr & other)
{

}

TStr::~TStr()
{

}

void TStr::accept(Visitor *v)
{
  v->visitTStr(this);
}

TStr *TStr::clone() const
{
  return new TStr(*this);
}



/********************   TBool    ********************/
TBool::TBool()
{

}

TBool::TBool(const TBool & other)
{

}

TBool &TBool::operator=(const TBool & other)
{
  TBool tmp(other);
  swap(tmp);
  return *this;
}

void TBool::swap(TBool & other)
{

}

TBool::~TBool()
{

}

void TBool::accept(Visitor *v)
{
  v->visitTBool(this);
}

TBool *TBool::clone() const
{
  return new TBool(*this);
}



/********************   TNVC    ********************/
TNVC::TNVC(ClassType *p1)
{
  classtype_ = p1;

}

TNVC::TNVC(const TNVC & other)
{
  classtype_ = other.classtype_->clone();

}

TNVC &TNVC::operator=(const TNVC & other)
{
  TNVC tmp(other);
  swap(tmp);
  return *this;
}

void TNVC::swap(TNVC & other)
{
  std::swap(classtype_, other.classtype_);

}

TNVC::~TNVC()
{
  delete(classtype_);

}

void TNVC::accept(Visitor *v)
{
  v->visitTNVC(this);
}

TNVC *TNVC::clone() const
{
  return new TNVC(*this);
}



/********************   TNVB    ********************/
TNVB::TNVB(BasicType *p1)
{
  basictype_ = p1;

}

TNVB::TNVB(const TNVB & other)
{
  basictype_ = other.basictype_->clone();

}

TNVB &TNVB::operator=(const TNVB & other)
{
  TNVB tmp(other);
  swap(tmp);
  return *this;
}

void TNVB::swap(TNVB & other)
{
  std::swap(basictype_, other.basictype_);

}

TNVB::~TNVB()
{
  delete(basictype_);

}

void TNVB::accept(Visitor *v)
{
  v->visitTNVB(this);
}

TNVB *TNVB::clone() const
{
  return new TNVB(*this);
}



/********************   TArray    ********************/
TArray::TArray(NonVoidType *p1)
{
  nonvoidtype_ = p1;

}

TArray::TArray(const TArray & other)
{
  nonvoidtype_ = other.nonvoidtype_->clone();

}

TArray &TArray::operator=(const TArray & other)
{
  TArray tmp(other);
  swap(tmp);
  return *this;
}

void TArray::swap(TArray & other)
{
  std::swap(nonvoidtype_, other.nonvoidtype_);

}

TArray::~TArray()
{
  delete(nonvoidtype_);

}

void TArray::accept(Visitor *v)
{
  v->visitTArray(this);
}

TArray *TArray::clone() const
{
  return new TArray(*this);
}



/********************   TSingle    ********************/
TSingle::TSingle(NonVoidType *p1)
{
  nonvoidtype_ = p1;

}

TSingle::TSingle(const TSingle & other)
{
  nonvoidtype_ = other.nonvoidtype_->clone();

}

TSingle &TSingle::operator=(const TSingle & other)
{
  TSingle tmp(other);
  swap(tmp);
  return *this;
}

void TSingle::swap(TSingle & other)
{
  std::swap(nonvoidtype_, other.nonvoidtype_);

}

TSingle::~TSingle()
{
  delete(nonvoidtype_);

}

void TSingle::accept(Visitor *v)
{
  v->visitTSingle(this);
}

TSingle *TSingle::clone() const
{
  return new TSingle(*this);
}



/********************   TVoid    ********************/
TVoid::TVoid()
{

}

TVoid::TVoid(const TVoid & other)
{

}

TVoid &TVoid::operator=(const TVoid & other)
{
  TVoid tmp(other);
  swap(tmp);
  return *this;
}

void TVoid::swap(TVoid & other)
{

}

TVoid::~TVoid()
{

}

void TVoid::accept(Visitor *v)
{
  v->visitTVoid(this);
}

TVoid *TVoid::clone() const
{
  return new TVoid(*this);
}



/********************   CastOnClass    ********************/
CastOnClass::CastOnClass(Ident p1)
{
  ident_ = p1;

}

CastOnClass::CastOnClass(const CastOnClass & other)
{
  ident_ = other.ident_;

}

CastOnClass &CastOnClass::operator=(const CastOnClass & other)
{
  CastOnClass tmp(other);
  swap(tmp);
  return *this;
}

void CastOnClass::swap(CastOnClass & other)
{
  std::swap(ident_, other.ident_);

}

CastOnClass::~CastOnClass()
{

}

void CastOnClass::accept(Visitor *v)
{
  v->visitCastOnClass(this);
}

CastOnClass *CastOnClass::clone() const
{
  return new CastOnClass(*this);
}



/********************   CastOnArr    ********************/
CastOnArr::CastOnArr(NonVoidType *p1)
{
  nonvoidtype_ = p1;

}

CastOnArr::CastOnArr(const CastOnArr & other)
{
  nonvoidtype_ = other.nonvoidtype_->clone();

}

CastOnArr &CastOnArr::operator=(const CastOnArr & other)
{
  CastOnArr tmp(other);
  swap(tmp);
  return *this;
}

void CastOnArr::swap(CastOnArr & other)
{
  std::swap(nonvoidtype_, other.nonvoidtype_);

}

CastOnArr::~CastOnArr()
{
  delete(nonvoidtype_);

}

void CastOnArr::accept(Visitor *v)
{
  v->visitCastOnArr(this);
}

CastOnArr *CastOnArr::clone() const
{
  return new CastOnArr(*this);
}



/********************   CastOnBasic    ********************/
CastOnBasic::CastOnBasic(BasicType *p1)
{
  basictype_ = p1;

}

CastOnBasic::CastOnBasic(const CastOnBasic & other)
{
  basictype_ = other.basictype_->clone();

}

CastOnBasic &CastOnBasic::operator=(const CastOnBasic & other)
{
  CastOnBasic tmp(other);
  swap(tmp);
  return *this;
}

void CastOnBasic::swap(CastOnBasic & other)
{
  std::swap(basictype_, other.basictype_);

}

CastOnBasic::~CastOnBasic()
{
  delete(basictype_);

}

void CastOnBasic::accept(Visitor *v)
{
  v->visitCastOnBasic(this);
}

CastOnBasic *CastOnBasic::clone() const
{
  return new CastOnBasic(*this);
}



/********************   ENewArr    ********************/
ENewArr::ENewArr(NonVoidType *p1, Expr *p2)
{
  nonvoidtype_ = p1;
  expr_ = p2;

}

ENewArr::ENewArr(const ENewArr & other)
{
  nonvoidtype_ = other.nonvoidtype_->clone();
  expr_ = other.expr_->clone();

}

ENewArr &ENewArr::operator=(const ENewArr & other)
{
  ENewArr tmp(other);
  swap(tmp);
  return *this;
}

void ENewArr::swap(ENewArr & other)
{
  std::swap(nonvoidtype_, other.nonvoidtype_);
  std::swap(expr_, other.expr_);

}

ENewArr::~ENewArr()
{
  delete(nonvoidtype_);
  delete(expr_);

}

void ENewArr::accept(Visitor *v)
{
  v->visitENewArr(this);
}

ENewArr *ENewArr::clone() const
{
  return new ENewArr(*this);
}



/********************   ENewCls    ********************/
ENewCls::ENewCls(Ident p1)
{
  ident_ = p1;

}

ENewCls::ENewCls(const ENewCls & other)
{
  ident_ = other.ident_;

  line_number = other.line_number;
}

ENewCls &ENewCls::operator=(const ENewCls & other)
{
  ENewCls tmp(other);
  swap(tmp);
  return *this;
}

void ENewCls::swap(ENewCls & other)
{
  std::swap(ident_, other.ident_);

}

ENewCls::~ENewCls()
{

}

void ENewCls::accept(Visitor *v)
{
  v->visitENewCls(this);
}

ENewCls *ENewCls::clone() const
{
  return new ENewCls(*this);
}



/********************   ELitInt    ********************/
ELitInt::ELitInt(Integer p1)
{
  integer_ = p1;

}

ELitInt::ELitInt(const ELitInt & other)
{
  integer_ = other.integer_;
  line_number = other.line_number;

}

ELitInt &ELitInt::operator=(const ELitInt & other)
{
  ELitInt tmp(other);
  swap(tmp);
  return *this;
}

void ELitInt::swap(ELitInt & other)
{
  std::swap(integer_, other.integer_);

}

ELitInt::~ELitInt()
{

}

void ELitInt::accept(Visitor *v)
{
  v->visitELitInt(this);
}

ELitInt *ELitInt::clone() const
{
  return new ELitInt(*this);
}



/********************   ELitTrue    ********************/
ELitTrue::ELitTrue()
{

}

ELitTrue::ELitTrue(const ELitTrue & other)
{

  line_number = other.line_number;
}

ELitTrue &ELitTrue::operator=(const ELitTrue & other)
{
  ELitTrue tmp(other);
  swap(tmp);
  return *this;
}

void ELitTrue::swap(ELitTrue & other)
{

}

ELitTrue::~ELitTrue()
{

}

void ELitTrue::accept(Visitor *v)
{
  v->visitELitTrue(this);
}

ELitTrue *ELitTrue::clone() const
{
  return new ELitTrue(*this);
}



/********************   ELitFalse    ********************/
ELitFalse::ELitFalse()
{

}

ELitFalse::ELitFalse(const ELitFalse & other)
{

  line_number = other.line_number;
}

ELitFalse &ELitFalse::operator=(const ELitFalse & other)
{
  ELitFalse tmp(other);
  swap(tmp);
  return *this;
}

void ELitFalse::swap(ELitFalse & other)
{

}

ELitFalse::~ELitFalse()
{

}

void ELitFalse::accept(Visitor *v)
{
  v->visitELitFalse(this);
}

ELitFalse *ELitFalse::clone() const
{
  return new ELitFalse(*this);
}



/********************   EString    ********************/
EString::EString(String p1)
{
  string_ = p1;

}

EString::EString(const EString & other)
{
  string_ = other.string_;
  line_number = other.line_number;

}

EString &EString::operator=(const EString & other)
{
  EString tmp(other);
  swap(tmp);
  return *this;
}

void EString::swap(EString & other)
{
  std::swap(string_, other.string_);

}

EString::~EString()
{

}

void EString::accept(Visitor *v)
{
  v->visitEString(this);
}

EString *EString::clone() const
{
  return new EString(*this);
}



/********************   EVar    ********************/
EVar::EVar(Ident p1)
{
  ident_ = p1;

}

EVar::EVar(const EVar & other)
{
  ident_ = other.ident_;
line_number = other.line_number;

}

EVar &EVar::operator=(const EVar & other)
{
  EVar tmp(other);
  swap(tmp);
  return *this;
}

void EVar::swap(EVar & other)
{
  std::swap(ident_, other.ident_);

}

EVar::~EVar()
{

}

void EVar::accept(Visitor *v)
{
  v->visitEVar(this);
}

EVar *EVar::clone() const
{
  return new EVar(*this);
}



/********************   ENull    ********************/
ENull::ENull()
{

}

ENull::ENull(const ENull & other)
{

line_number = other.line_number;
}

ENull &ENull::operator=(const ENull & other)
{
  ENull tmp(other);
  swap(tmp);
  return *this;
}

void ENull::swap(ENull & other)
{

}

ENull::~ENull()
{

}

void ENull::accept(Visitor *v)
{
  v->visitENull(this);
}

ENull *ENull::clone() const
{
  return new ENull(*this);
}



/********************   EMemb    ********************/
EMemb::EMemb(Expr *p1, Ident p2)
{
  expr_ = p1;
  ident_ = p2;

}

EMemb::EMemb(const EMemb & other)
{
  expr_ = other.expr_->clone();
  ident_ = other.ident_;
line_number = other.line_number;

}

EMemb &EMemb::operator=(const EMemb & other)
{
  EMemb tmp(other);
  swap(tmp);
  return *this;
}

void EMemb::swap(EMemb & other)
{
  std::swap(expr_, other.expr_);
  std::swap(ident_, other.ident_);

}

EMemb::~EMemb()
{
  delete(expr_);

}

void EMemb::accept(Visitor *v)
{
  v->visitEMemb(this);
}

EMemb *EMemb::clone() const
{
  return new EMemb(*this);
}



/********************   EFunCall    ********************/
EFunCall::EFunCall(Ident p1, ListExpr *p2)
{
  ident_ = p1;
  listexpr_ = p2;

}

EFunCall::EFunCall(const EFunCall & other)
{
  ident_ = other.ident_;
  listexpr_ = other.listexpr_->clone();
line_number = other.line_number;

}

EFunCall &EFunCall::operator=(const EFunCall & other)
{
  EFunCall tmp(other);
  swap(tmp);
  return *this;
}

void EFunCall::swap(EFunCall & other)
{
  std::swap(ident_, other.ident_);
  std::swap(listexpr_, other.listexpr_);

}

EFunCall::~EFunCall()
{
  delete(listexpr_);

}

void EFunCall::accept(Visitor *v)
{
  v->visitEFunCall(this);
}

EFunCall *EFunCall::clone() const
{
  return new EFunCall(*this);
}



/********************   EMembCall    ********************/
EMembCall::EMembCall(Expr *p1, Ident p2, ListExpr *p3)
{
  expr_ = p1;
  ident_ = p2;
  listexpr_ = p3;

}

EMembCall::EMembCall(const EMembCall & other)
{
  expr_ = other.expr_->clone();
  ident_ = other.ident_;
  listexpr_ = other.listexpr_->clone();

line_number = other.line_number;
}

EMembCall &EMembCall::operator=(const EMembCall & other)
{
  EMembCall tmp(other);
  swap(tmp);
  return *this;
}

void EMembCall::swap(EMembCall & other)
{
  std::swap(expr_, other.expr_);
  std::swap(ident_, other.ident_);
  std::swap(listexpr_, other.listexpr_);

}

EMembCall::~EMembCall()
{
  delete(expr_);
  delete(listexpr_);

}

void EMembCall::accept(Visitor *v)
{
  v->visitEMembCall(this);
}

EMembCall *EMembCall::clone() const
{
  return new EMembCall(*this);
}



/********************   EAt    ********************/
EAt::EAt(Expr *p1, Expr *p2)
{
  expr_1 = p1;
  expr_2 = p2;

}

EAt::EAt(const EAt & other)
{
  expr_1 = other.expr_1->clone();
  expr_2 = other.expr_2->clone();
line_number = other.line_number;

}

EAt &EAt::operator=(const EAt & other)
{
  EAt tmp(other);
  swap(tmp);
  return *this;
}

void EAt::swap(EAt & other)
{
  std::swap(expr_1, other.expr_1);
  std::swap(expr_2, other.expr_2);

}

EAt::~EAt()
{
  delete(expr_1);
  delete(expr_2);

}

void EAt::accept(Visitor *v)
{
  v->visitEAt(this);
}

EAt *EAt::clone() const
{
  return new EAt(*this);
}



/********************   ECast    ********************/
ECast::ECast(CastOn *p1, Expr *p2)
{
  caston_ = p1;
  expr_ = p2;

}

ECast::ECast(const ECast & other)
{
  caston_ = other.caston_->clone();
  expr_ = other.expr_->clone();
line_number = other.line_number;

}

ECast &ECast::operator=(const ECast & other)
{
  ECast tmp(other);
  swap(tmp);
  return *this;
}

void ECast::swap(ECast & other)
{
  std::swap(caston_, other.caston_);
  std::swap(expr_, other.expr_);

}

ECast::~ECast()
{
  delete(caston_);
  delete(expr_);

}

void ECast::accept(Visitor *v)
{
  v->visitECast(this);
}

ECast *ECast::clone() const
{
  return new ECast(*this);
}



/********************   Neg    ********************/
Neg::Neg(Expr *p1)
{
  expr_ = p1;

}

Neg::Neg(const Neg & other)
{
  expr_ = other.expr_->clone();

line_number = other.line_number;
}

Neg &Neg::operator=(const Neg & other)
{
  Neg tmp(other);
  swap(tmp);
  return *this;
}

void Neg::swap(Neg & other)
{
  std::swap(expr_, other.expr_);

}

Neg::~Neg()
{
  delete(expr_);

}

void Neg::accept(Visitor *v)
{
  v->visitNeg(this);
}

Neg *Neg::clone() const
{
  return new Neg(*this);
}



/********************   Not    ********************/
Not::Not(Expr *p1)
{
  expr_ = p1;

}

Not::Not(const Not & other)
{
  expr_ = other.expr_->clone();

line_number = other.line_number;
}

Not &Not::operator=(const Not & other)
{
  Not tmp(other);
  swap(tmp);
  return *this;
}

void Not::swap(Not & other)
{
  std::swap(expr_, other.expr_);

}

Not::~Not()
{
  delete(expr_);

}

void Not::accept(Visitor *v)
{
  v->visitNot(this);
}

Not *Not::clone() const
{
  return new Not(*this);
}



/********************   EMul    ********************/
EMul::EMul(Expr *p1, MulOp *p2, Expr *p3)
{
  expr_1 = p1;
  mulop_ = p2;
  expr_2 = p3;

}

EMul::EMul(const EMul & other)
{
  expr_1 = other.expr_1->clone();
  mulop_ = other.mulop_->clone();
  expr_2 = other.expr_2->clone();

line_number = other.line_number;
}

EMul &EMul::operator=(const EMul & other)
{
  EMul tmp(other);
  swap(tmp);
  return *this;
}

void EMul::swap(EMul & other)
{
  std::swap(expr_1, other.expr_1);
  std::swap(mulop_, other.mulop_);
  std::swap(expr_2, other.expr_2);

}

EMul::~EMul()
{
  delete(expr_1);
  delete(mulop_);
  delete(expr_2);

}

void EMul::accept(Visitor *v)
{
  v->visitEMul(this);
}

EMul *EMul::clone() const
{
  return new EMul(*this);
}



/********************   EAdd    ********************/
EAdd::EAdd(Expr *p1, AddOp *p2, Expr *p3)
{
  expr_1 = p1;
  addop_ = p2;
  expr_2 = p3;

}

EAdd::EAdd(const EAdd & other)
{
  expr_1 = other.expr_1->clone();
  addop_ = other.addop_->clone();
  expr_2 = other.expr_2->clone();
line_number = other.line_number;

}

EAdd &EAdd::operator=(const EAdd & other)
{
  EAdd tmp(other);
  swap(tmp);
  return *this;
}

void EAdd::swap(EAdd & other)
{
  std::swap(expr_1, other.expr_1);
  std::swap(addop_, other.addop_);
  std::swap(expr_2, other.expr_2);

}

EAdd::~EAdd()
{
  delete(expr_1);
  delete(addop_);
  delete(expr_2);

}

void EAdd::accept(Visitor *v)
{
  v->visitEAdd(this);
}

EAdd *EAdd::clone() const
{
  return new EAdd(*this);
}



/********************   ERel    ********************/
ERel::ERel(Expr *p1, RelOp *p2, Expr *p3)
{
  expr_1 = p1;
  relop_ = p2;
  expr_2 = p3;

}

ERel::ERel(const ERel & other)
{
  expr_1 = other.expr_1->clone();
  relop_ = other.relop_->clone();
  expr_2 = other.expr_2->clone();

line_number = other.line_number;
}

ERel &ERel::operator=(const ERel & other)
{
  ERel tmp(other);
  swap(tmp);
  return *this;
}

void ERel::swap(ERel & other)
{
  std::swap(expr_1, other.expr_1);
  std::swap(relop_, other.relop_);
  std::swap(expr_2, other.expr_2);

}

ERel::~ERel()
{
  delete(expr_1);
  delete(relop_);
  delete(expr_2);

}

void ERel::accept(Visitor *v)
{
  v->visitERel(this);
}

ERel *ERel::clone() const
{
  return new ERel(*this);
}



/********************   EAnd    ********************/
EAnd::EAnd(Expr *p1, Expr *p2)
{
  expr_1 = p1;
  expr_2 = p2;

}

EAnd::EAnd(const EAnd & other)
{
  expr_1 = other.expr_1->clone();
  expr_2 = other.expr_2->clone();
line_number = other.line_number;

}

EAnd &EAnd::operator=(const EAnd & other)
{
  EAnd tmp(other);
  swap(tmp);
  return *this;
}

void EAnd::swap(EAnd & other)
{
  std::swap(expr_1, other.expr_1);
  std::swap(expr_2, other.expr_2);

}

EAnd::~EAnd()
{
  delete(expr_1);
  delete(expr_2);

}

void EAnd::accept(Visitor *v)
{
  v->visitEAnd(this);
}

EAnd *EAnd::clone() const
{
  return new EAnd(*this);
}



/********************   EOr    ********************/
EOr::EOr(Expr *p1, Expr *p2)
{
  expr_1 = p1;
  expr_2 = p2;

}

EOr::EOr(const EOr & other)
{
  expr_1 = other.expr_1->clone();
  expr_2 = other.expr_2->clone();

line_number = other.line_number;
}

EOr &EOr::operator=(const EOr & other)
{
  EOr tmp(other);
  swap(tmp);
  return *this;
}

void EOr::swap(EOr & other)
{
  std::swap(expr_1, other.expr_1);
  std::swap(expr_2, other.expr_2);

}

EOr::~EOr()
{
  delete(expr_1);
  delete(expr_2);

}

void EOr::accept(Visitor *v)
{
  v->visitEOr(this);
}

EOr *EOr::clone() const
{
  return new EOr(*this);
}



/********************   Plus    ********************/
Plus::Plus()
{

}

Plus::Plus(const Plus & other)
{

  line_number = other.line_number;
}

Plus &Plus::operator=(const Plus & other)
{
  Plus tmp(other);
  swap(tmp);
  return *this;
}

void Plus::swap(Plus & other)
{

}

Plus::~Plus()
{

}

void Plus::accept(Visitor *v)
{
  v->visitPlus(this);
}

Plus *Plus::clone() const
{
  return new Plus(*this);
}



/********************   Minus    ********************/
Minus::Minus()
{

}

Minus::Minus(const Minus & other)
{

  line_number = other.line_number;
}

Minus &Minus::operator=(const Minus & other)
{
  Minus tmp(other);
  swap(tmp);
  return *this;
}

void Minus::swap(Minus & other)
{

}

Minus::~Minus()
{

}

void Minus::accept(Visitor *v)
{
  v->visitMinus(this);
}

Minus *Minus::clone() const
{
  return new Minus(*this);
}



/********************   Times    ********************/
Times::Times()
{

}

Times::Times(const Times & other)
{

  line_number = other.line_number;
}

Times &Times::operator=(const Times & other)
{
  Times tmp(other);
  swap(tmp);
  return *this;
}

void Times::swap(Times & other)
{

}

Times::~Times()
{

}

void Times::accept(Visitor *v)
{
  v->visitTimes(this);
}

Times *Times::clone() const
{
  return new Times(*this);
}



/********************   Div    ********************/
Div::Div()
{

}

Div::Div(const Div & other)
{

}

Div &Div::operator=(const Div & other)
{
  Div tmp(other);
  swap(tmp);
  return *this;
}

void Div::swap(Div & other)
{

}

Div::~Div()
{

}

void Div::accept(Visitor *v)
{
  v->visitDiv(this);
}

Div *Div::clone() const
{
  return new Div(*this);
}



/********************   Mod    ********************/
Mod::Mod()
{

}

Mod::Mod(const Mod & other)
{

}

Mod &Mod::operator=(const Mod & other)
{
  Mod tmp(other);
  swap(tmp);
  return *this;
}

void Mod::swap(Mod & other)
{

}

Mod::~Mod()
{

}

void Mod::accept(Visitor *v)
{
  v->visitMod(this);
}

Mod *Mod::clone() const
{
  return new Mod(*this);
}



/********************   LTH    ********************/
LTH::LTH()
{

}

LTH::LTH(const LTH & other)
{

}

LTH &LTH::operator=(const LTH & other)
{
  LTH tmp(other);
  swap(tmp);
  return *this;
}

void LTH::swap(LTH & other)
{

}

LTH::~LTH()
{

}

void LTH::accept(Visitor *v)
{
  v->visitLTH(this);
}

LTH *LTH::clone() const
{
  return new LTH(*this);
}



/********************   LE    ********************/
LE::LE()
{

}

LE::LE(const LE & other)
{

}

LE &LE::operator=(const LE & other)
{
  LE tmp(other);
  swap(tmp);
  return *this;
}

void LE::swap(LE & other)
{

}

LE::~LE()
{

}

void LE::accept(Visitor *v)
{
  v->visitLE(this);
}

LE *LE::clone() const
{
  return new LE(*this);
}



/********************   GTH    ********************/
GTH::GTH()
{

}

GTH::GTH(const GTH & other)
{

}

GTH &GTH::operator=(const GTH & other)
{
  GTH tmp(other);
  swap(tmp);
  return *this;
}

void GTH::swap(GTH & other)
{

}

GTH::~GTH()
{

}

void GTH::accept(Visitor *v)
{
  v->visitGTH(this);
}

GTH *GTH::clone() const
{
  return new GTH(*this);
}



/********************   GE    ********************/
GE::GE()
{

}

GE::GE(const GE & other)
{

}

GE &GE::operator=(const GE & other)
{
  GE tmp(other);
  swap(tmp);
  return *this;
}

void GE::swap(GE & other)
{

}

GE::~GE()
{

}

void GE::accept(Visitor *v)
{
  v->visitGE(this);
}

GE *GE::clone() const
{
  return new GE(*this);
}



/********************   EQU    ********************/
EQU::EQU()
{

}

EQU::EQU(const EQU & other)
{

}

EQU &EQU::operator=(const EQU & other)
{
  EQU tmp(other);
  swap(tmp);
  return *this;
}

void EQU::swap(EQU & other)
{

}

EQU::~EQU()
{

}

void EQU::accept(Visitor *v)
{
  v->visitEQU(this);
}

EQU *EQU::clone() const
{
  return new EQU(*this);
}



/********************   NE    ********************/
NE::NE()
{

}

NE::NE(const NE & other)
{

}

NE &NE::operator=(const NE & other)
{
  NE tmp(other);
  swap(tmp);
  return *this;
}

void NE::swap(NE & other)
{

}

NE::~NE()
{

}

void NE::accept(Visitor *v)
{
  v->visitNE(this);
}

NE *NE::clone() const
{
  return new NE(*this);
}




/********************   ListTopDef    ********************/

void ListTopDef::accept(Visitor *v)
{
  v->visitListTopDef(this);
}


ListTopDef *ListTopDef::clone() const
{
  return new ListTopDef(*this);
}


/********************   ListArg    ********************/

void ListArg::accept(Visitor *v)
{
  v->visitListArg(this);
}


ListArg *ListArg::clone() const
{
  return new ListArg(*this);
}


/********************   ListClsFldDefItem    ********************/

void ListClsFldDefItem::accept(Visitor *v)
{
  v->visitListClsFldDefItem(this);
}


ListClsFldDefItem *ListClsFldDefItem::clone() const
{
  return new ListClsFldDefItem(*this);
}


/********************   ListClassBlockDef    ********************/

void ListClassBlockDef::accept(Visitor *v)
{
  v->visitListClassBlockDef(this);
}


ListClassBlockDef *ListClassBlockDef::clone() const
{
  return new ListClassBlockDef(*this);
}


/********************   ListStmt    ********************/

void ListStmt::accept(Visitor *v)
{
  v->visitListStmt(this);
}


ListStmt *ListStmt::clone() const
{
  return new ListStmt(*this);
}


/********************   ListDeclItem    ********************/

void ListDeclItem::accept(Visitor *v)
{
  v->visitListDeclItem(this);
}


ListDeclItem *ListDeclItem::clone() const
{
  return new ListDeclItem(*this);
}


/********************   ListExpr    ********************/

void ListExpr::accept(Visitor *v)
{
  v->visitListExpr(this);
}


ListExpr *ListExpr::clone() const
{
  return new ListExpr(*this);
}



}
